INCLUDE    89C51.MC
		SDA EQU P3.6
		SCL EQU P3.7
;***********************************
ORG 0000H
MAIN:		MOV R7,#4
		MOV 1AH,#45
  		ACALL WRITE
		ACALL DELAY
		ACALL READ
		ACALL TOBCD
		ACALL HIEN_THI
		SJMP $
;***********************************
;**************************************		
WRITE:	ACALL START
		MOV A, #10100000B
		ACALL GUI_BYTE
		MOV A,R7
		ACALL GUI_BYTE
		MOV A,1AH
		ACALL GUI_BYTE
		ACALL STOP
		RET
;*************************************
READ:		ACALL START
		MOV A,#10100000B
		ACALL GUI_BYTE
		MOV A,R7
		ACALL GUI_BYTE
		ACALL START
		MOV A,#10100001B
		ACALL GUI_BYTE
		ACALL GET_BYTE
		ACALL GIVE_NOACK
		ACALL STOP
		RET
;******************************************
START:	SETB SDA
		NOP
		NOP
		SETB SCL
		NOP
		NOP
		NOP
		NOP
		NOP
		CLR SDA
		NOP
		NOP
		NOP
		NOP
		NOP
		CLR SCL
		RET
;******************************************
GET_ACK:	SETB SDA
		NOP
		NOP
		NOP
		SETB SCL
ACKBIT:	MOV C,SDA
		JC ACKBIT
		CLR SCL
		RET
;******************************************
GUI_BYTE:	MOV R0,#8
NBITS:	RLC A
		MOV SDA,C
		NOP
		SETB SCL
		NOP 
		NOP
		NOP
		NOP
		NOP
		CLR SCL
		DJNZ R0,NBITS
	      ACALL GET_ACK
		RET
;**************************************
GIVE_NOACK: SETB SDA
		NOP
		NOP
		SETB SCL
		NOP
		NOP
		NOP
		NOP
		NOP
		CLR SCL
		RET
;*************************************
STOP:		CLR SDA
		NOP
		NOP
		NOP
		SETB SCL
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		SETB SDA
		RET
;***************************************
GET_BYTE:	MOV R0,#8
		MOV A,#00H
		CLR C
NBITR:	SETB SCL
		NOP
		MOV C,SDA
		NOP
		NOP
		NOP
		RLC A
		CLR SCL
		NOP
		NOP
		DJNZ R0, NBITR
		MOV 1AH,A
		NOP 
		NOP
		SETB SDA
		RET
;******************************************
GIVE_ACK:	CLR SDA
		NOP
		NOP
		SETB SCL
		NOP
		NOP
		NOP
		NOP
		NOP
		CLR SCL
		SETB SDA
		RET
;***************************************		
TOBCD:
		MOV A,1AH
		MOV B,#10
		DIV AB
		MOV 18H,A
		MOV A,B
		MOV 19H,A
		RET
;****************************************

HIEN_THI:  		MOV A,18H
			ACALL XUATLED
			MOV P0,A
			MOV A,19H
			ACALL XUATLED
			MOV P2,A
			RET
;****************************************************
XUATLED: 		MOV DPTR,#TABLE
			MOVC A,@A+DPTR
			RET
;************************************************
DELAY:	
			MOV R5,#2
		LOP: 	MOV R6,#250
			DJNZ R6,$
			DJNZ R5,LOP
			RET
;**************************************************
		
TABLE: DB C0H,F9H,A4H,B0H,99H,92H,83H,F8H,80H,90H
		